#include <exec/types.h>
#include <pragmas/exec.h>
#include <pragmas/keymap.h>
#include <string.h>

struct myQual
	{
		char *str;
		UWORD qual;
	};

struct myQual Quals[] =
	{
		"lshift",	0x1,
		"rshift",	0x2,
		"ctrl",		0x8,
		"lalt",		0x10,
		"ralt",		0x20,
		"lcmd",		0x40,
		"rcmd",		0x80,
		NULL,			0
	};


int __saveds __asm Qual (register __a0 char *cmdline, register __a2 APTR table[])
{
	char *p;
	int qual;
	struct myQual *mq;
	char __regargs * (*GetString)(char *);

	GetString = table[9];
	p = GetString (cmdline);

	qual = 0;
	mq = Quals;
	while (mq->str)
		{
			if (!strcmp (mq->str,p))
				{
					qual = (int)(mq->qual);
					break;
				}
			mq++;
		}

	return (qual);
}
